;-------------------------------------------------------
;row 0: B'10000000'
;row 1: B'11000000'
;row 2: B'10010100'
;row 3: B'11010100'
;-------------------------------------------------------
;    ld      a,00001100b             ;switch off the cursor
;    ld      a,00001111b             ;switch on  the cursor
;    call    send_comm
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
    jp      start
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;Usable routines
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
    jp      disp_clr2               ;call 0003h: clear LCD + switoch off the cursor
    jp      reg_show_no_dc          ;call 0006h: show registers w/o LCD clear
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
start:
    ld      hl,7FFFh
    ld      sp,hl                   ;init SP - at the top of 32kB block
    
    call    disp_init
    call    w_welcome

    ld      bc,0080h
    call    delo
;-------------------------------------------------------
;-------------------------------------------------------
; Determine installed memory: 8kB / 16kB / 32kB / 64kB
; for 0000h - 7FFFh
;    8 kB   -> v_ram = 01h
;   16 kB   -> v_ram = 02h
;   32 kB   -> v_ram = 03h
;-------------------------------------------------------
;-------------------------------------------------------
    ld      a,01h
    ld      (01FFFh),a
    ld      a,02h
    ld      (07FFFh),a

    ld      a,(01FFFh)
    cp      02h
    jp      z,ram08

    ld      a,(03FFFh)
    cp      02h
    jp      z,ram16

    jp      ram32
;-------------------------------------------------------
    ld      a,(07FFFh)
    cp      02h
    jp      z,ram32
    
    jp      ram32
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
ram08:
    ld      a,01h
    ld      (v_ram),a
    jp      main_entry
;-------------------------------------------------------
ram16:
    ld      a,02h
    ld      (v_ram),a
    jp      main_entry
;-------------------------------------------------------
ram32:
    ld      a,03h
    ld      (v_ram),a

;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
main_entry:
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
    call    w_main

main_loop:    
    call    read_key
    cp      10h
    jp      z,demos_main

    cp      18h
    jp      z,i2c_main

    cp      19h
    jp      z,rtc_main

    cp      1Ah
    jp      z,monitor_main

    cp      1Bh
    jp      z,exec_main
    
    cp      1Ch
    jp      z,reg_frame
       
    jp      main_loop
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;I2C communication using Port PC:
;    PC0 = I2C SCL output only
;    PC1 = I2C SDA output
;    PC4 = I2C SDA input
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
i2c_main:
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr

    ld      a,80h
    call    send_comm
    call    wm_I
    call    wm_2
    call    wm_C
    
    call    i2c_init
;------------------------------------------------------
i2c_loop:
    call    pcf8574_d1
    call    read_key
    cp      1Eh
    jp      z,main_entry
      
    jp      i2c_loop
;-------------------------------------------------------
;-------------------------------------------------------
pcf8574_d1:
    ld      iy,i2c_buffer
    ld      (iy),40h
    call    i2c_start
    call    i2c_send_w_LCD

    call    pcf8574_d1_p1
    call    pcf8574_d1_p1
    call    pcf8574_d1_p1
    call    pcf8574_d1_p2
    call    pcf8574_d1_p3
    
    call    i2c_stop
    ret
;-------------------------------------------------------
;-------------------------------------------------------
pcf8574_d1_p1
    ld      (iy),11111110b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11111101b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11111011b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11110111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11101111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11011111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),10111111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),01111111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay

    ret
;-------------------------------------------------------
;-------------------------------------------------------
pcf8574_d1_p2
    ld      (iy),11111111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11111110b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11111100b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11111000b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11110000b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11100000b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),11000000b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
  
    ld      (iy),10000000b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),00000000b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ret
;-------------------------------------------------------
;-------------------------------------------------------
pcf8574_d1_p3
    ld      (iy),00000001b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),00000011b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),00000111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),00001111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),00011111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),00111111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ld      (iy),01111111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
  
    ld      (iy),11111111b
    call    i2c_send_w_LCD
    call    pcf8574_d1_delay
    
    ret
;-------------------------------------------------------
;-------------------------------------------------------
pcf8574_d1_delay
    ld  de,0800h
deli_d1:
    dec de
    ld  a,d
    or  e
    jp  nz,deli_d1
    
    ret 
;-------------------------------------------------------

;-------------------------------------------------------
;-------------------------------------------------------
;I2C communication routines
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
i2c_init
    ld      a,10001000b     ;8255 mode 0
                            ;PA      = output
                            ;PB      = output
                            ;PC high = input
                            ;PC low  = output
    out     (03h),a
    
    call    i2c_sda_1
    call    i2c_scl_1
    ret
;-------------------------------------------------------
i2c_start
    call    i2c_scl_1
    call    i2c_sda_0
    
    call    i2c_scl_0
    call    i2c_sda_0
    nop
    ret
;-------------------------------------------------------
i2c_stop
    call    i2c_scl_0
    call    i2c_sda_0
    
    call    i2c_scl_1
    call    i2c_sda_0
    
    call    i2c_scl_1
    call    i2c_sda_1
    nop
    ret
;-------------------------------------------------------
i2c_send
    ld      a,(i2c_buffer)
    bit     7,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    bit     6,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    bit     5,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    bit     4,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    bit     3,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    bit     2,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    bit     1,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    bit     0,a
    call    z, i2c_send_bit0
    call    nz,i2c_send_bit1
    
    ld      a,(i2c_buffer)
    call    i2c_receive_bit         ;ACK / NOT ACK
    
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
i2c_send_w_LCD
    ld      a,11010100b
    call    send_comm
    call    wm_S
    call    wm_e
    call    wm_n
    call    wm_d
    call    wm_dvojbodka
    call    wm_space
    
    ld      a,(i2c_buffer)
    call    w_bin8_a
    
    call    i2c_send
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------


;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;I2C bit operations
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
i2c_send_bit0
    call    i2c_scl_0
    call    i2c_sda_0
    
    call    i2c_scl_1
    call    i2c_sda_0

    call    i2c_scl_0
    call    i2c_sda_0
    ret
;-------------------------------------------------------
i2c_send_bit1
    call    i2c_scl_0
    call    i2c_sda_1
    
    call    i2c_scl_1
    call    i2c_sda_1
    
    call    i2c_scl_0
    call    i2c_sda_1
    
    ret
;-------------------------------------------------------
i2c_receive_bit
    jp      i2c_send_bit1
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;I2C SDA / SCL line basic operations
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
i2c_sda_1
    ld      a,00000011b
    out     (03h),a         ;SDA := 1
    ret
;-------------------------------------------------------
i2c_sda_0
    ld      a,00000010b
    out     (03h),a         ;SDA := 0
    ret
;-------------------------------------------------------
i2c_scl_1
    ld      a,00000001b
    out     (03h),a         ;SCL := 1
    ret
;-------------------------------------------------------
i2c_scl_0
    ld      a,00000000b
    out     (03h),a         ;SCL := 0
    ret
;-------------------------------------------------------
;-------------------------------------------------------
i2c_delay_1:
    ld  d,255
i2c_del1:
    dec d
    jp  nz,i2c_del1
    ret 
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
; Real Time Clock
;     (1) = Start Clock
;     (2) = Stop  Clock
;     (3) = Take over date & time from 1EF0
;                 1EF0 = 00 (ms)
;                 1EF1 = sec
;                 1EF2 = min
;                 1EF3 = hrs
;                 1EF4 = wday
;                 1EF5 = day
;                 1EF6 = mnt
;                 1EF7 = year
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
rtc_main
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_R
    call    wm_T
    call    wm_C
    call    wm_space
    call    wm_minus
    call    wm_space
    call    wm_P
    call    wm_h
    call    wm_a
    call    wm_n
    call    wm_t
    call    wm_o
    call    wm_m
    call    wm_space
    call    wm_c
    call    wm_l
    call    wm_o
    call    wm_c
    call    wm_k

rtc_loop
    call    rtc_activate_access
    call    rtc_read
    
    ld      ix,rtc_hrs
    ld      a,(ix)
    cp      0ffh
    jp      z,no_clock
    
    call    rtc_write_time
    call    rtc_write_date
    nop
;-------------------------------------------------------
rtc_loop_c:
    call    read_key
    
    cp      11h
    call    z,rtc_start
    
    cp      12h
    call    z,rtc_stop

    cp      13h
    call    z,rtc_take_over

    cp      1Eh
    jp      z,main_entry
    
    jp      rtc_loop
;-------------------------------------------------------
;-------------------------------------------------------
no_clock
    ld      a,11000000b
    call    send_comm
    call    wm_N
    call    wm_o
    call    wm_space
    call    wm_c
    call    wm_l
    call    wm_o
    call    wm_c
    call    wm_k
    call    wm_space
    call    wm_f
    call    wm_o
    call    wm_u
    call    wm_n
    call    wm_d
    jp      rtc_loop_c
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
rtc_take_over
    ld      ix,rtc_buffer
    ld      iy,1EF0h
    ld      a,(iy)
    ld      (ix),a
    
    inc     ix
    inc     iy
    ld      a,(iy)
    ld      (ix),a
    
    inc     ix
    inc     iy
    ld      a,(iy)
    ld      (ix),a
    
    inc     ix
    inc     iy
    ld      a,(iy)
    ld      (ix),a
    
    inc     ix
    inc     iy
    ld      a,(iy)
    ld      (ix),a
    
    inc     ix
    inc     iy
    ld      a,(iy)
    ld      (ix),a
    
    inc     ix
    inc     iy
    ld      a,(iy)
    ld      (ix),a
    
    inc     ix
    inc     iy
    ld      a,(iy)
    ld      (ix),a
    
    ld      a,(rtc_wday)    
    res     5,a
    set     4,a
    ld      (rtc_wday),a
    call    rtc_activate_access
    call    rtc_write
    
    ld      a,11010100b
    call    send_comm
    
    call    wm_C
    call    wm_l
    call    wm_o
    call    wm_c
    call    wm_k
    call    wm_space
    call    wm_s
    call    wm_e
    call    wm_t
    
    call    delay1
    
    call    disp_clr_line4
    ret
;-------------------------------------------------------
;-------------------------------------------------------
rtc_start
    ld      a,(rtc_wday)
    res     5,a
    ld      (rtc_wday),a
    call    rtc_activate_access
    call    rtc_write
    
    ld      a,11010100b
    call    send_comm
    
    call    wm_C
    call    wm_l
    call    wm_o
    call    wm_c
    call    wm_k
    call    wm_space
    call    wm_s
    call    wm_t
    call    wm_a
    call    wm_r
    call    wm_t
    call    wm_e
    call    wm_d
    
    call    delay1
    
    call    disp_clr_line4
    ret
;-------------------------------------------------------
;-------------------------------------------------------
rtc_stop
    ld      a,(rtc_wday)
    set     5,a
    ld      (rtc_wday),a
    call    rtc_activate_access
    call    rtc_write
    
    ld      a,11010100b
    call    send_comm
    
    call    wm_C
    call    wm_l
    call    wm_o
    call    wm_c
    call    wm_k
    call    wm_space
    call    wm_s
    call    wm_t
    call    wm_o
    call    wm_p
    call    wm_p
    call    wm_e
    call    wm_d
    
    call    delay1
    
    call    disp_clr_line4
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
rtc_write_date
    ld      a,10010100b
    call    send_comm
    
    call    wm_D
    call    wm_a
    call    wm_t
    call    wm_e
    call    wm_dvojbodka
    call    wm_space

    ld      ix,rtc_day
    ld      a,(ix)
    call    w_hex_a
    ld      a,'.'
    call    send_data
    
    inc     ix
    ld      a,(ix)
    call    w_hex_a
    ld      a,'.'
    call    send_data
    
    call    wm_2
    call    wm_0
    inc     ix
    ld      a,(ix)
    call    w_hex_a
    
    call    wm_space
    call    wm_space

    ld      a,(rtc_wday)
    and     0Fh
    cp      1
    jp      z,rtc_w_d1

    cp      2
    jp      z,rtc_w_d2
    
    cp      3
    jp      z,rtc_w_d3
    
    cp      4
    jp      z,rtc_w_d4
    
    cp      5
    jp      z,rtc_w_d5
    
    cp      6
    jp      z,rtc_w_d6
    
    cp      7
    jp      z,rtc_w_d7
    
    ret
;-------------------------------------------------------
;-------------------------------------------------------   
rtc_w_d1
    call    wm_M
    call    wm_o
    ret
;-------------------------------------------------------   
rtc_w_d2
    call    wm_T
    call    wm_u
    ret
;-------------------------------------------------------   
rtc_w_d3
    call    wm_W
    call    wm_e
    ret
;-------------------------------------------------------   
rtc_w_d4
    call    wm_T
    call    wm_h
    ret
;-------------------------------------------------------   
rtc_w_d5
    call    wm_F
    call    wm_r
    ret
;-------------------------------------------------------   
rtc_w_d6
    call    wm_S
    call    wm_a
    ret
;-------------------------------------------------------   
rtc_w_d7
    call    wm_S
    call    wm_u
    ret
;-------------------------------------------------------
;-------------------------------------------------------
rtc_write_time
    ld      a,11000000b
    call    send_comm
    
    call    wm_T
    call    wm_i
    call    wm_m
    call    wm_e
    call    wm_dvojbodka
    call    wm_space
    
    ld      ix,rtc_hrs
    ld      a,(ix)
    call    w_hex_a
    call    wm_dvojbodka
    
    dec     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_dvojbodka

    dec     ix
    ld      a,(ix)
    call    w_hex_a
    ld      a,','
    call    send_data

    dec     ix
    ld      a,(ix)
    call    w_hex_a
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
rtc_write_hex
    ld      a,11000000b
    call    send_comm
    
    ld      ix,rtc_buffer
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus
    
    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus

    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus

    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus
;-------------------------------------
    ld      a,10010100b
    call    send_comm
    
    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus
    
    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus

    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus

    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_minus


    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------

;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;write 8 bytes to RTC
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
rtc_write
    ld      ix,rtc_buffer
    ld      a,(ix)
    call    rtc_write_byte
    
    inc     ix
    ld      a,(ix)
    call    rtc_write_byte
    
    inc     ix
    ld      a,(ix)
    call    rtc_write_byte
    
    inc     ix
    ld      a,(ix)
    call    rtc_write_byte
    
    inc     ix
    ld      a,(ix)
    call    rtc_write_byte
    
    inc     ix
    ld      a,(ix)
    call    rtc_write_byte
    
    inc     ix
    ld      a,(ix)
    call    rtc_write_byte
    
    inc     ix
    ld      a,(ix)
    call    rtc_write_byte

    ret
;-------------------------------------------------------
;-------------------------------------------------------
rtc_write_byte
    ld      (8000h),a       ;bit 0
    rra
    ld      (8000h),a       ;bit 1
    rra
    ld      (8000h),a       ;bit 2
    rra
    ld      (8000h),a       ;bit 3
    rra
    ld      (8000h),a       ;bit 4
    rra
    ld      (8000h),a       ;bit 5
    rra
    ld      (8000h),a       ;bit 6
    rra
    ld      (8000h),a       ;bit 7
    rra
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;read 8 bytes from RTC
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
rtc_read
    ld      ix,rtc_buffer
    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    call    rtc_read_byte
    ld      (ix),a
    inc     ix

    ret
;-------------------------------------------------------
;-------------------------------------------------------
rtc_read_byte
    ld      a,(8000h)       ;bit 0
    and     01h
    ld      b,a

    ld      a,(8000h)       ;bit 1
    and     01h
    rla
    add     a,b
    ld      b,a

    ld      a,(8000h)       ;bit 2
    and     01h
    rla
    rla
    add     a,b
    ld      b,a

    ld      a,(8000h)       ;bit 3
    and     01h
    rla
    rla
    rla
    add     a,b
    ld      b,a

    ld      a,(8000h)       ;bit 4
    and     01h
    rla
    rla
    rla
    rla
    add     a,b
    ld      b,a

    ld      a,(8000h)       ;bit 5
    and     01h
    rla
    rla
    rla
    rla
    rla
    add     a,b
    ld      b,a

    ld      a,(8000h)       ;bit 6
    and     01h
    rla
    rla
    rla
    rla
    rla
    rla
    add     a,b
    ld      b,a

    ld      a,(8000h)       ;bit 7
    and     01h
    rla
    rla
    rla
    rla
    rla
    rla
    rla
    add     a,b
    ld      b,a

    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
rtc_activate_access
    ld      a,0c5h
    call    rtc_aa_send_byte
    ld      a,03ah
    call    rtc_aa_send_byte
    ld      a,0a3h
    call    rtc_aa_send_byte
    ld      a,05ch
    call    rtc_aa_send_byte
    ld      a,0c5h
    call    rtc_aa_send_byte
    ld      a,03ah
    call    rtc_aa_send_byte
    ld      a,0a3h
    call    rtc_aa_send_byte
    ld      a,05ch
    call    rtc_aa_send_byte
    ret
;-------------------------------------------------------
;-------------------------------------------------------
rtc_aa_send_byte
    ld      (8000h),a       ;bit 0
    rra
    ld      (8000h),a       ;bit 1
    rra
    ld      (8000h),a       ;bit 2
    rra
    ld      (8000h),a       ;bit 3
    rra
    ld      (8000h),a       ;bit 4
    rra
    ld      (8000h),a       ;bit 5
    rra
    ld      (8000h),a       ;bit 6
    rra
    ld      (8000h),a       ;bit 7
    rra
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
demos_main
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_zat1
    call    wm_1
    call    wm_zat2
    call    wm_space
    call    wm_7
    call    wm_4
    call    wm_L
    call    wm_S
    call    wm_1
    call    wm_7
    call    wm_5

    ld      a,11000000b
    call    send_comm
    call    wm_zat1
    call    wm_2
    call    wm_zat2
    call    wm_space
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    
    call    delay1
;--------------------------
demos_loop
    call    read_key
    cp      11h
    jp      z,main74175
    
    cp      12h
    jp      z,main8255

    cp      1Eh
    jp      z,main_entry
    
    jp      demos_loop
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
; 8255 I/O demo routines
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
main8255
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    
    ld      a,11000000b
    call    send_comm
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus

    ld      a,10010100b
    call    send_comm
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_zat1
    call    wm_1
    call    wm_zat2
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_zat1
    call    wm_C
    call    wm_zat2

    ld      a,11010100b
    call    send_comm
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_zat1
    call    wm_2
    call    wm_zat2
    
    call    wm_space
    call    wm_zat1
    call    wm_3
    call    wm_zat2

    call    wm_space
    call    wm_zat1
    call    wm_4
    call    wm_zat2

    call    wm_space
    call    wm_zat1
    call    wm_5
    call    wm_zat2

    call    delay1
    call    delay1
;--------------------------
m8255_loop
    call    read_key
    cp      11h
    jp      z,m8255_demo1
    
    cp      12h
    jp      z,m8255_demo2

    cp      13h
    jp      z,m8255_demo3

    cp      14h
    jp      z,m8255_demo4

    cp      15h
    jp      z,m8255_demo5

    cp      1Ch
    jp      z,m8255_demo_cube

    cp      1Eh
    jp      z,demos_main
    
    jp      m8255_loop
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
m8255_demo_cube
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    call    wm_space
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_C
    call    wm_u
    call    wm_b
    call    wm_e

;--------------------------    
    ld      a,10000000b
    out     (03h),a                 ;config: mode 0; all I/O as outputs

    ld      ix,v_counter
    ld      (ix),01h

m8255_loop_cube
    ld      a,11001000b
    call    send_comm
    call    w_cube_LCD
    call    cube_show_number

    call    delay1
    inc     (ix)
    ld      a,(ix)
    cp      07h
    jp      nz,loop_cube_cont
    ld      (ix),01h
loop_cube_cont:
    call    read_key
    cp      1Eh
    jp      z,main8255
    
    jp      m8255_loop_cube
;-------------------------------------------------------
cube_show_number:
    ld      a,(ix)
    cp      00h
    jp      z,wm_cube_0
    cp      01h
    jp      z,wm_cube_1
    cp      02h
    jp      z,wm_cube_2
    cp      03h
    jp      z,wm_cube_3
    cp      04h
    jp      z,wm_cube_4
    cp      05h
    jp      z,wm_cube_5
    cp      06h
    jp      z,wm_cube_6

    jp      wm_cube_0
;-------------------------------------------------------
;-------------------------------------------------------
wm_cube_0
    ld      a,00h
    out     (00h),a
    ret
;-------------------------------------------------------
wm_cube_1
    ld      a,00001000b
    out     (00h),a
    ret
;-------------------------------------------------------
wm_cube_2
    ld      a,01000100b
    out     (00h),a
    ret
;-------------------------------------------------------
wm_cube_3
    ld      a,01001100b
    out     (00h),a
    ret
;-------------------------------------------------------
wm_cube_4
    ld      a,01010101b
    out     (00h),a
    ret
;-------------------------------------------------------
wm_cube_5
    ld      a,01011101b
    out     (00h),a
    ret
;-------------------------------------------------------
wm_cube_6
    ld      a,01110111b
    out     (00h),a
    ret
;-------------------------------------------------------
;-------------------------------------------------------
w_cube_LCD:
    ld      a,(ix)
    cp      00h
    jp      z,wm_cube_LCD0
    cp      01h
    jp      z,wm_cube_LCD1
    cp      02h
    jp      z,wm_cube_LCD2
    cp      03h
    jp      z,wm_cube_LCD3
    cp      04h
    jp      z,wm_cube_LCD4
    cp      05h
    jp      z,wm_cube_LCD5
    cp      06h
    jp      z,wm_cube_LCD6

    jp      wm_cube_0
;-------------------------------------------------------
;-------------------------------------------------------
wm_cube_LCD0
    ld      a,11010010b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space

    ld      a,10100110b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space

    ld      a,11100110b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space
    
    ret
;-------------------------------------------------------
wm_cube_LCD1
    ld      a,11010001b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space

    ld      a,10100101b
    call    send_comm
    call    wm_space
    call    wm_CX
    call    wm_space

    ld      a,11100101b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space
    
    ret
;-------------------------------------------------------
wm_cube_LCD2
    ld      a,11010001b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_CX

    ld      a,10100101b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space

    ld      a,11100101b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_space
    
    ret
;-------------------------------------------------------
wm_cube_LCD3
    ld      a,11010001b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_CX

    ld      a,10100101b
    call    send_comm
    call    wm_space
    call    wm_CX
    call    wm_space

    ld      a,11100101b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_space
    
    ret
;-------------------------------------------------------
wm_cube_LCD4
    ld      a,11010001b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_CX

    ld      a,10100101b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space

    ld      a,11100101b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_CX
    
    ret
;-------------------------------------------------------
wm_cube_LCD5
    ld      a,11010001b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_CX

    ld      a,10100101b
    call    send_comm
    call    wm_space
    call    wm_CX
    call    wm_space

    ld      a,11100101b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_CX
    
    ret
;-------------------------------------------------------
wm_cube_LCD6
    ld      a,11010001b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_CX

    ld      a,10100101b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_CX

    ld      a,11100101b
    call    send_comm
    call    wm_CX
    call    wm_space
    call    wm_CX
    
    ret
;-------------------------------------------------------
;-------------------------------------------------------
wm_CX
    ld      a,0FFh
    call    send_data
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
m8255_demo5
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    call    wm_space
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_5

    ld      iy,demo5_data
    jp      m8255_demo_generic
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
m8255_demo4
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    call    wm_space
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_4

    ld      iy,demo4_data
    jp      m8255_demo_generic
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
m8255_demo3
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    call    wm_space
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_3

    ld      iy,demo3_data
    jp      m8255_demo_generic
;-------------------------------------------------------
;-------------------------------------------------------
m8255_demo2
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    call    wm_space
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_2

    ld      iy,demo2_data
    jp      m8255_demo_generic
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
m8255_demo_generic:
    ld      a,11000000b
    call    send_comm
    call    wm_D
    call    wm_e
    call    wm_f
    call    wm_space
    call    wm_a
    call    wm_d
    call    wm_d
    call    wm_dvojbodka
    call    wm_space
    push    iy
    pop     hl
    call    mon_show_16bit
    call    wm_h
;----------------------------
    ld      a,10010100b
    call    send_comm
    call    wm_L
    call    wm_e
    call    wm_n
    call    wm_dvojbodka
    call    wm_space
    push    iy
    pop     ix
    inc     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_h
    
    call    wm_space
    call    wm_space
    
    call    wm_D
    call    wm_e
    call    wm_l
    call    wm_a
    call    wm_y
    call    wm_dvojbodka
    call    wm_space
    
    push    iy
    pop     ix
    ld      a,(ix)
    call    w_hex_a
    call    wm_h
;---------------------------    
    ld      a,11010100b
    call    send_comm
    
    call    wm_P
    call    wm_o
    call    wm_r
    call    wm_t
    call    wm_space
    call    wm_A
    call    wm_dvojbodka

;--------------------------    
    ld      a,10000000b
    out     (03h),a                 ;config: mode 0; all I/O as outputs

m8255_loop_d2o
    push    iy
    pop     ix
    ld      d,(ix)                  ;used delay
    inc     ix
    ld      c,(ix)                  ;data length
    inc     ix
m8255_loop_d2
    push    de
    ld      a,11011100b
    call    send_comm
    ld      a,(ix)
    call    w_bin8_a
    out     (00h),a
    pop     de
    call    delay1s
    inc     ix
   
    call    read_key
    cp      1Eh
    jp      z,main8255
    
    dec     c
    jp      nz,m8255_loop_d2
    
    jp      m8255_loop_d2o
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
m8255_demo1
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_8
    call    wm_2
    call    wm_5
    call    wm_5
    
    ld      a,11000000b
    call    send_comm
    call    wm_P
    call    wm_o
    call    wm_r
    call    wm_t
    call    wm_space
    call    wm_A
    call    wm_dvojbodka

    ld      a,10010100b
    call    send_comm
    call    wm_P
    call    wm_o
    call    wm_r
    call    wm_t
    call    wm_space
    call    wm_C
    call    wm_dvojbodka    
    
    ld      ix,v_counter
    ld      (ix),00h
;--------------------------    
    ld      a,10000000b
    out     (03h),a                 ;config: mode 0; all I/O as outputs

m8255_loop_d1
    ld      a,11001000b
    call    send_comm
    ld      a,(ix)
    call    w_bin8_a
    
    ld      a,10011100b
    call    send_comm
    ld      a,(ix)
    call    w_bin8_a
    
    out     (00h),a                 ;8255->PORT A
    out     (02h),a                 ;8255->PORT C
    call    delay1
    inc     (ix)
   
    call    read_key
    cp      1Eh
    jp      z,main8255
    
    jp      m8255_loop_d1
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
reg_show_no_dc:
    push    af
    push    bc
    push    de
    push    hl
;-------------------------------------------------------
    push    hl
    push    de
    push    bc
    push    af
    jp      reg_show2
;-------------------------------------------------------    
;-------------------------------------------------------
;-------------------------------------------------------
reg_show:
    push    af
    push    bc
    push    de
    push    hl
;-------------------------------------------------------
    push    hl
    push    de
    push    bc
    push    af
;-------------------------------------------------------    
    call    disp_clr
;-------------------------------------------------------
reg_show2:
;show AF register
    ld      a,10000000b
    call    send_comm
    call    wm_A
    call    wm_F
    call    wm_dvojbodka
    call    wm_space
    pop     hl              ;reload AF to HL
    call    mon_show_16bit
;-------------------------------------------------------
;show F-register: bit by bit
    ld      a,10011110b
    call    send_comm
    call    wm_S
    call    wm_Z
    call    wm_X
    call    wm_H
    call    wm_X
    call    wm_P
    call    wm_N
    call    wm_C
    
    ld      a,11011110b
    call    send_comm
    ld      a,l
    call    w_bin8_a
;-------------------------------------------------------
;show SP register
    ld      a,10001010b
    call    send_comm
    call    wm_S
    call    wm_P
    call    wm_dvojbodka
    call    wm_space
    
    ld      hl,00h
    add     hl,sp
    call    mon_show_16bit
;-------------------------------------------------------
;show IX register
    ld      a,11001010b
    call    send_comm
    call    wm_I
    call    wm_X
    call    wm_dvojbodka
    call    wm_space
    
    push    ix
    pop     hl
    call    mon_show_16bit
;-------------------------------------------------------
;show BC register
    ld      a,11000000b
    call    send_comm
    call    wm_B
    call    wm_C
    call    wm_dvojbodka
    call    wm_space
    pop     hl              ;reload BC to HL
    call    mon_show_16bit
;-------------------------------------------------------
;show DE register
    ld      a,10010100b
    call    send_comm
    call    wm_D
    call    wm_E
    call    wm_dvojbodka
    call    wm_space
    pop     hl              ;reload DE to HL
    call    mon_show_16bit
;-------------------------------------------------------
;show HL register
    ld      a,11010100b
    call    send_comm
    call    wm_H
    call    wm_L
    call    wm_dvojbodka
    call    wm_space
    pop     hl
    call    mon_show_16bit
;-------------------------------------------------------
    pop     hl
    pop     de
    pop     bc
    pop     af
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
reg_frame:
    call    reg_show
reg_loop:
    call    read_key
    cp      1Eh
    jp      z,main_entry

    jp      reg_loop
;-------------------------------------------------------

;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
exec_main:
    call    disp_clr
    ld      hl,2000h
    call    mon_show_add
;edit address --------------------------------------------------
    ld      ix,edit_hex_byte
    ld      (ix),h                  ;value to be edited
    ld      iy, edit_hex_dp
    ld      (iy),081h               ;starting position of LCD
    
    call    edit_byte
    cp      01h
    jp      z,main_entry            ;* = Cancel
    cp      02h                     ;D = Save and next
    jp      z,exec_rfsh_sh          ;continue with data editing

    ld      a,(ix)
    ld      h,a
;---------------------------------------------------------------    
    ld      ix,edit_hex_byte
    ld      (ix),l                  ;value to be edited
    ld      iy, edit_hex_dp
    ld      (iy),083h               ;starting position of LCD
    
    call    edit_byte
    cp      01h
    jp      z,main_entry            ;* = Cancel
;---------------------------------------------------------------
    ld      a,(ix)
    ld      l,a
    jp      exec_rfsh
;---------------------------------------------------------------
exec_rfsh_sh:
    ld      a,(ix)
    ld      h,a
    jp      exec_rfsh
;---------------------------------------------------------------
;---------------------------------------------------------------
;-------------------------------------------------------
exec_rfsh:
    ld      a,00001111b             ;switch on the cursor
    call    send_comm
    ld      a,86h
    call    send_comm

exec_loop:
    call    read_key
    cp      1Eh
    jp      z,main_entry

    cp      1Dh
    jp      z,exec_execute
    
    jp      exec_loop
;-------------------------------------------------------
;-------------------------------------------------------
exec_execute:
    ld      a,10010100b
    call    send_comm
    ld      a,'>'
    call    send_data
    call    wm_r
    call    wm_u
    call    wm_n
    call    wm_n
    call    wm_i
    call    wm_n
    call    wm_g
    call    wm_bodka
    call    wm_bodka
    call    wm_bodka

    call    ex_ex_jp
    
    ld      a,10010100b
    call    send_comm
    ld      a,'>'
    call    send_data
    call    wm_d
    call    wm_o
    call    wm_n
    call    wm_e
    call    wm_bodka
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space

    call    delay5
    
    jp      exec_main
;-------------------------------------------------------
ex_ex_jp:
    jp      (hl)
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
monitor_main:
    call    disp_clr
    ld      hl,2000h
    call    mon_show_add
;edit address --------------------------------------------------
    ld      ix,edit_hex_byte
    ld      (ix),h                  ;value to be edited
    ld      iy, edit_hex_dp
    ld      (iy),081h               ;starting position of LCD
    
    call    edit_byte
    cp      01h
    jp      z,main_entry            ;* = Cancel
    cp      02h                     ;D = Save and next
    jp      z,monitor_rfsh_sh       ;continue with data editing

    ld      a,(ix)
    ld      h,a
;---------------------------------------------------------------    
    ld      ix,edit_hex_byte
    ld      (ix),l                  ;value to be edited
    ld      iy, edit_hex_dp
    ld      (iy),083h               ;starting position of LCD
    
    call    edit_byte
    cp      01h
    jp      z,main_entry            ;* = Cancel
;---------------------------------------------------------------
    ld      a,(ix)
    ld      l,a
    jp      monitor_rfsh
;---------------------------------------------------------------
monitor_rfsh_sh:
    ld      a,(ix)
    ld      h,a
    jp      monitor_rfsh
;---------------------------------------------------------------
;---------------------------------------------------------------
monitor_rfsh:
    call    mon_show_add

    call    wm_space
    ld      a,(hl)
    call    w_hex_a

    call    w_show_minus
    call    w_show_8_bytes

    ld      ix,edit_hex_byte
    ld      a,(hl)
    ld      (ix),a                  ;value to be edited
    
    ld      iy, edit_hex_dp
    ld      (iy),086h               ;starting position of LCD
monitor_byte:
    call    edit_byte
    ld      a,b
    cp      00h
    jp      z,monitor_byte
    cp      01h                     ;* = cancel
    jp      z,main_entry
    cp      02h                     ;D = Save and next
    jp      z,mon_save_inc
    cp      03h                     ;# = Save and previous
    jp      z,mon_save_dec

    jp      monitor_rfsh


mon_save_inc:
    ld      a,(ix)
    ld      (hl),a
    inc     hl
    jp      monitor_rfsh
mon_save_dec:
    ld      a,(ix)
    ld      (hl),a
    dec     hl
    jp      monitor_rfsh
;-------------------------------------------------------
;-------------------------------------------------------
mon_show_add:
    ld      a,80h
    call    send_comm
    ld      a,'>'
    call    send_data

mon_show_16bit:
    ld      a,h
    call    w_hex_a
    ld      a,l
    call    w_hex_a
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
edit_byte_exit1:
    ld      b,01h                   ;star pressed - exit w/o save
    ret
;-------------------------------------------------------
edit_byte_exit2:
    ld      b,02h                   ;D pressed - save and next
    ret
;-------------------------------------------------------
edit_byte_exit3:
    ld      b,03h                   ;# pressed - save and pervious
    ret
;-------------------------------------------------------
;-------------------------------------------------------
edit_byte:
    ld      a,00001111b             ;switch on the cursor
    call    send_comm
    ld      a,(iy)
    call    send_comm

monitor_loop_high:
    call    read_key
    cp      1Eh
    jp      z,edit_byte_exit1
    cp      1Dh
    jp      z,edit_byte_exit2
    cp      1Fh
    jp      z,edit_byte_exit3

; -- test: has been a key 0-F pressed? ----------------
    ld      b,a
    and     0F0h
    cp      00h
    jp      nz,monitor_loop_high
; -- yes: now we have to modify the original value ----
    ld      a,(ix)
    and     0fh
    ld      (ix),a
    
    ld      a,b
    and     0Fh
    rla
    rla
    rla
    rla

    add     a,(ix)
    ld      (ix),a
;-------------------------------------------------------
    ld      a,(iy)
    call    send_comm
    ld      a,(ix)
    call    w_hex_a

    ld      a,(iy)
    inc     a
    call    send_comm

    call    kbd_del3
monitor_loop_low:
    call    read_key
    cp      1Eh
    jp      z,edit_byte_exit1
    cp      1Dh
    jp      z,edit_byte_exit2
    cp      1Fh
    jp      z,edit_byte_exit3

; -- test: has been a key 0-F pressed? ----------------
    ld      b,a
    and     0F0h
    cp      00h
    jp      nz,monitor_loop_low
; -- yes: now we have to modify the original value ----
    ld      a,(ix)
    and     0f0h
    ld      (ix),a
    
    ld      a,b
    and     0Fh

    add     a,(ix)
    ld      (ix),a
    
    ld      b,00h           ;no special key pressed

    ld      a,(iy)
    call    send_comm
    ld      a,(ix)
    call    w_hex_a

    call    kbd_del3
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_show_minus:
    ld      a,11000000b
    call    send_comm
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    ret
;-------------------------------------------------------
;-------------------------------------------------------
w_show_8_bytes:
    push    hl
    
    dec     hl
    dec     hl
    dec     hl
    dec     hl
    
    ld      a,10010100b
    call    send_comm

    ld      a,h
    call    w_hex_a
    ld      a,l
    call    w_hex_a

    call    wm_dvojbodka
    call    wm_space
    
    call    w_show_4_bytes
;-----------------------------
    ld      a,11010100b
    call    send_comm
 
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    
    inc     hl
    call    w_show_4_bytes
    
    pop     hl
;--- show >  < ----------------
    ld      a,11011001b
    call    send_comm
    ld      a,'>'
    call    send_data

    ld      a,11011100b
    call    send_comm
    ld      a,'<'
    call    send_data
;------------------------------
    
    ret
;-------------------------------------------------------
w_show_4_bytes:
    ld      a,(hl)
    call    w_hex_a
    call    wm_space
 
    inc     hl
    ld      a,(hl)
    call    w_hex_a
    call    wm_space

    inc     hl
    ld      a,(hl)
    call    w_hex_a
    call    wm_space

    inc     hl
    ld      a,(hl)
    call    w_hex_a
    call    wm_space
    
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
mon_memory:
    ld      a,80h
    out     (20h),a
    call    delay1
    ld      a,'>'
    out     (21h),a
    call    delay1
mon_loop:
    ld      a,81h
    out     (20h),a
    call    delay1
  
    call    keyboard_test
    jp      mon_loop
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
read_key:
    push    hl
    call    kbd_get_key
    ld      hl,kbd_buffer
    ld      a,(hl)
    pop     hl
    ret
;-------------------------------------------------------
;-------------------------------------------------------
kbd_get_key
    ld      hl,kbd_buffer
    
;    in      a,(11000001b)           ;I/O address for 74LS05
    in      a,(11001110b)           ;I/O address for 74LS07
    cp      11111110b
    jp      z,kbd_L1
    
    cp      11111101b
    jp      z,kbd_L2
    
    cp      11111011b
    jp      z,kbd_L3

    cp      11110111b
    jp      z,kbd_LA

    cp      11101111b
    jp      z,kbd_R1

    cp      11011111b
    jp      z,kbd_R2

    cp      10111111b
    jp      z,kbd_R3

    cp      01111111b
    jp      z,kbd_RA
;-------------------------------------------------------
;    in      a,(11000010b)           ;I/O address for 74LS05
    in      a,(11001101b)           ;I/O address for 74LS07
    cp      11111110b
    jp      z,kbd_L4
    
    cp      11111101b
    jp      z,kbd_L5
    
    cp      11111011b
    jp      z,kbd_L6

    cp      11110111b
    jp      z,kbd_LB

    cp      11101111b
    jp      z,kbd_R4

    cp      11011111b
    jp      z,kbd_R5

    cp      10111111b
    jp      z,kbd_R6

    cp      01111111b
    jp      z,kbd_RB
;-------------------------------------------------------
;    in      a,(11000100b)           ;I/O address for 74LS05
    in      a,(11001011b)           ;I/O address for 74LS07
    cp      11111110b
    jp      z,kbd_L7
    
    cp      11111101b
    jp      z,kbd_L8
    
    cp      11111011b
    jp      z,kbd_L9

    cp      11110111b
    jp      z,kbd_LC

    cp      11101111b
    jp      z,kbd_R7

    cp      11011111b
    jp      z,kbd_R8

    cp      10111111b
    jp      z,kbd_R9

    cp      01111111b
    jp      z,kbd_RC
;-------------------------------------------------------
;-------------------------------------------------------
;    in      a,(11001000b)           ;I/O address for 74LS05
    in      a,(11000111b)           ;I/O address for 74LS07
    cp      11111110b
    jp      z,kbd_Lstar
    
    cp      11111101b
    jp      z,kbd_L0
    
    cp      11111011b
    jp      z,kbd_Lmrizka

    cp      11110111b
    jp      z,kbd_LD

    cp      11101111b
    jp      z,kbd_Rstar

    cp      11011111b
    jp      z,kbd_R0

    cp      10111111b
    jp      z,kbd_Rmrizka

    cp      01111111b
    jp      z,kbd_RD
;-------------------------------------------------------
    ld      (hl),0FFh
    ret
;-------------------------------------------------------
;-------------------------------------------------------
kbd_L1:
    ld      (hl),001h
    ret
;------------------------------
kbd_L2:
    ld      (hl),002h
    ret
;------------------------------
kbd_L3:
    ld      (hl),003h
    ret
;------------------------------
kbd_L4:
    ld      (hl),004h
    ret
;------------------------------
kbd_L5:
    ld      (hl),005h
    ret
;------------------------------
kbd_L6:
    ld      (hl),006h
    ret
;------------------------------
kbd_L7:
    ld      (hl),007h
    ret
;------------------------------
kbd_L8:
    ld      (hl),008h
    ret
;------------------------------
kbd_L9:
    ld      (hl),009h
    ret
;------------------------------
kbd_L0:
    ld      (hl),000h
    ret
;------------------------------
kbd_LA:
    ld      (hl),00ah
    ret
;------------------------------
kbd_LB:
    ld      (hl),00bh
    ret
;------------------------------
kbd_LC:
    ld      (hl),00ch
    ret
;------------------------------
kbd_LD:
    ld      (hl),00dh
    ret
;------------------------------
kbd_Lstar:
    ld      (hl),00Eh
    ret
;------------------------------
kbd_Lmrizka:
    ld      (hl),00Fh
    ret
;------------------------------
;------------------------------
kbd_R1:
    ld      (hl),011h
    ret
;------------------------------
kbd_R2:
    ld      (hl),012h
    ret
;------------------------------
kbd_R3:
    ld      (hl),013h
    ret
;------------------------------
kbd_R4:
    ld      (hl),014h
    ret
;------------------------------
kbd_R5:
    ld      (hl),015h
    ret
;------------------------------
kbd_R6:
    ld      (hl),016h
    ret
;------------------------------
kbd_R7:
    ld      (hl),017h
    ret
;------------------------------
kbd_R8:
    ld      (hl),018h
    ret
;------------------------------
kbd_R9:
    ld      (hl),019h
    ret
;------------------------------
kbd_R0:
    ld      (hl),010h
    ret
;------------------------------
kbd_RA:
    ld      (hl),01ah
    ret
;------------------------------
kbd_RB:
    ld      (hl),01bh
    ret
;------------------------------
kbd_RC:
    ld      (hl),01ch
    ret
;------------------------------
kbd_RD:
    ld      (hl),01dh
    ret
;------------------------------
kbd_Rstar:
    ld      (hl),01Eh
    ret
;------------------------------
kbd_Rmrizka:
    ld      (hl),01Fh
    ret
;------------------------------
;------------------------------

;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
keyboard_test:
    in      a,(0c1h)
    push    af
    cp      11111110b
    call    z,w_kbd_L1
    pop     af
    
    push    af
    cp      11111101b
    call    z,w_kbd_L2
    pop     af
    
    push    af
    cp      11111011b
    call    z,w_kbd_L3
    pop     af

    push    af
    cp      11110111b
    call    z,w_kbd_LA
    pop     af

    push    af
    cp      11101111b
    call    z,w_kbd_R1
    pop     af

    push    af
    cp      11011111b
    call    z,w_kbd_R2
    pop     af

    push    af
    cp      10111111b
    call    z,w_kbd_R3
    pop     af

    push    af
    cp      01111111b
    call    z,w_kbd_RA
    pop     af
;-------------------------------------------------------
    in      a,(0c2h)
    push    af
    cp      11111110b
    call    z,w_kbd_L4
    pop     af
    
    push    af
    cp      11111101b
    call    z,w_kbd_L5
    pop     af
    
    push    af
    cp      11111011b
    call    z,w_kbd_L6
    pop     af

    push    af
    cp      11110111b
    call    z,w_kbd_LB
    pop     af

    push    af
    cp      11101111b
    call    z,w_kbd_R4
    pop     af

    push    af
    cp      11011111b
    call    z,w_kbd_R5
    pop     af

    push    af
    cp      10111111b
    call    z,w_kbd_R6
    pop     af

    push    af
    cp      01111111b
    call    z,w_kbd_RB
    pop     af
;-------------------------------------------------------
    in      a,(0c4h)
    push    af
    cp      11111110b
    call    z,w_kbd_L7
    pop     af
    
    push    af
    cp      11111101b
    call    z,w_kbd_L8
    pop     af
    
    push    af
    cp      11111011b
    call    z,w_kbd_L9
    pop     af

    push    af
    cp      11110111b
    call    z,w_kbd_LC
    pop     af

    push    af
    cp      11101111b
    call    z,w_kbd_R7
    pop     af

    push    af
    cp      11011111b
    call    z,w_kbd_R8
    pop     af

    push    af
    cp      10111111b
    call    z,w_kbd_R9
    pop     af

    push    af
    cp      01111111b
    call    z,w_kbd_RC
    pop     af
;-------------------------------------------------------
;-------------------------------------------------------
    in      a,(0c8h)
    push    af
    cp      11111110b
    call    z,w_kbd_Lstar
    pop     af
    
    push    af
    cp      11111101b
    call    z,w_kbd_L0
    pop     af
    
    push    af
    cp      11111011b
    call    z,w_kbd_Lmrizka
    pop     af

    push    af
    cp      11110111b
    call    z,w_kbd_LD
    pop     af

    push    af
    cp      11101111b
    call    z,w_kbd_Rstar
    pop     af

    push    af
    cp      11011111b
    call    z,w_kbd_R0
    pop     af

    push    af
    cp      10111111b
    call    z,w_kbd_Rmrizka
    pop     af

    push    af
    cp      01111111b
    call    z,w_kbd_RD
    pop     af
;-------------------------------------------------------
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
get_key_smoke:
    ld      a,10010100b
    out     (20h),a
    call    delay1
    in      a,(0c1h)
    call    w_bin8_a
    call    wm_space
    call    wm_space
        
    in      a,(0c2h)
    call    w_bin8_a

    ld      a,11010100b
    out     (20h),a
    call    delay1
    in      a,(0c4h)
    call    w_bin8_a
    call    wm_space
    call    wm_space
    
    in      a,(0c8h)
    call    w_bin8_a
    
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
demo1_3x:
    call    demo1_core
    call    demo1_core
    call    demo1_core
    ret
;-------------------------------------------------------
demo1_core:
    nop
    ld      a,01h
    call    w_bin8_a_demo1
    out     (255), a
    call    delay1
    call    read_key
    cp      1eh
    ret     z
    
    ld      a,02h
    call    w_bin8_a_demo1
    out     (255), a
    call    delay1
    call    read_key
    cp      1eh
    ret     z
    
    ld      a,04h
    call    w_bin8_a_demo1
    out     (255), a
    call    delay1
    call    read_key
    cp      1eh
    ret     z
    
    ld      a,08h
    call    w_bin8_a_demo1
    out     (255), a
    call    delay1
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;74LS175 Demo Routines
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
main74175
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
    call    disp_clr
;--------------------------
    ld      a,80h
    call    send_comm
    call    wm_7
    call    wm_4
    call    wm_L
    call    wm_S
    call    wm_1
    call    wm_7
    call    wm_5
    
    ld      a,11000000b
    call    send_comm
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    call    wm_minus
    
    ld      a,10010100b
    call    send_comm
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_zat1
    call    wm_1
    call    wm_zat2

    ld      a,11010100b
    call    send_comm
    call    wm_D
    call    wm_e
    call    wm_m
    call    wm_o
    call    wm_space
    call    wm_zat1
    call    wm_2
    call    wm_zat2
    
    call    delay1
    call    delay1
;--------------------------
m74175_loop
    call    read_key
    cp      11h
    jp      z,demo1_main
    
    cp      12h
    jp      z,demo2_main

    cp      1Eh
    jp      z,demos_main
    
    jp      m74175_loop
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
demo2_main:
    call    disp_clr
    
demo2_loop:
    ld      a,00000110b
    call    w_bin8_a_demo1
    out     (255), a
    call    delay1
    ld      a,00001001b
    call    w_bin8_a_demo1
    out     (255), a
    call    delay1
    
    call    read_key
    cp      1eh
    jp      z,main74175
    
    jp      demo2_loop
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
demo1_main:
    call    disp_clr
    
demo1_loop:
    call    demo1_core
    call    read_key
    cp      1eh
    jp      z,main74175
    jp      demo1_loop
;-------------------------------------------------------
;-------------------------------------------------------
w_bin8_a_demo1:
    push    af
    ld      a,80h
    out     (20h),a
    call    disp_del2
    call    wm_L
    call    wm_E
    call    wm_D
    call    wm_dvojbodka
    call    wm_space
    pop     af
    call    w_bin8_a
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
disp_init:
    call    delay1
    
    ld      a,30h
    out     (20h),a
    call    delay1
    ld      a,30h
    out     (20h),a
    call    delay1
    ld      a,30h
    out     (20h),a
    call    disp_del2
    ld      a,38h
    out     (20h),a
    call    disp_del2

    ld      a,08h
    out     (20h),a
    call    disp_del2

    ld      a,01h
    out     (20h),a
    call    disp_del2

    ld      a,06h
    out     (20h),a
    call    disp_del2

    ld      a,0Ch
    out     (20h),a
    call    disp_del2

    ret
;-------------------------------------------------------
;-------------------------------------------------------
send_comm:
    push    af
    out     (20h),a
    call    disp_del2
    pop     af
    ret
;-------------------------------------------------------
;-------------------------------------------------------
send_data:
    push    af
    out     (21h),a
    call    disp_del_data
    pop     af
    ret
;-------------------------------------------------------
;-------------------------------------------------------
disp_clr2:
    ld      a,00001100b             ;switch off the cursor
    call    send_comm
disp_clr:
    ld      a,01h
    call    send_comm
    ret
;-------------------------------------------------------
;-------------------------------------------------------
disp_clr_line4
    ld      a,11010100b
    call    send_comm
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    call    wm_space
    ret
;-------------------------------------------------------
;-------------------------------------------------------
wm_0:
    ld      a,'0'
    out     (21h),a
    call    disp_del_data
    ret
;-------------------------------------------------------
wm_1:
    ld      a,'1'
    call    send_data
    ret
;-------------------------------------------------------
wm_2:
    ld      a,'2'
    call    send_data
    ret
;-------------------------------------------------------
wm_3:
    ld      a,'3'
    call    send_data
    ret
;-------------------------------------------------------
wm_4:
    ld      a,'4'
    call    send_data
    ret
;-------------------------------------------------------
wm_5:
    ld      a,'5'
    call    send_data
    ret
;-------------------------------------------------------
wm_6:
    ld      a,'6'
    call    send_data
    ret
;-------------------------------------------------------
wm_7:
    ld      a,'7'
    call    send_data
    ret
;-------------------------------------------------------
wm_8:
    ld      a,'8'
    call    send_data
    ret
;-------------------------------------------------------
wm_9:
    ld      a,'9'
    call    send_data
    ret
;-------------------------------------------------------
wm_A:
    ld      a,'A'
    call    send_data
    ret
;-------------------------------------------------------
wm_B:
    ld      a,'B'
    call    send_data
    ret
;-------------------------------------------------------
wm_C:
    ld      a,'C'
    call    send_data
    ret
;-------------------------------------------------------
wm_D:
    ld      a,'D'
    call    send_data
    ret
;-------------------------------------------------------
wm_E:
    ld      a,'E'
    call    send_data
    ret
;-------------------------------------------------------
wm_F:
    ld      a,'F'
    call    send_data
    ret
;-------------------------------------------------------
wm_H:
    ld      a,'H'
    call    send_data
    ret
;-------------------------------------------------------
wm_I:
    ld      a,'I'
    call    send_data
    ret
;-------------------------------------------------------
wm_L:
    ld      a,'L'
    call    send_data
    ret
;-------------------------------------------------------
wm_M:
    ld      a,'M'
    call    send_data
    ret
;-------------------------------------------------------
wm_N:
    ld      a,'N'
    call    send_data
    ret
;-------------------------------------------------------
wm_P:
    ld      a,'P'
    call    send_data
    ret
;-------------------------------------------------------
wm_R:
    ld      a,'R'
    call    send_data
    ret
;-------------------------------------------------------
wm_S:
    ld      a,'S'
    call    send_data
    ret
;-------------------------------------------------------
wm_T
    ld      a,'T'
    call    send_data
    ret
;-------------------------------------------------------
wm_W
    ld      a,'W'
    call    send_data
    ret
;-------------------------------------------------------
wm_X:
    ld      a,'X'
    call    send_data
    ret
;-------------------------------------------------------
wm_Z:
    ld      a,'Z'
    call    send_data
    ret
;-------------------------------------------------------
wm_a:
    ld      a,'a'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_b:
    ld      a,'b'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_c:
    ld      a,'c'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_d:
    ld      a,'d'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_e:
    ld      a,'e'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_f:
    ld      a,'f'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_h:
    ld      a,'h'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_k:
    ld      a,'k'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_l:
    ld      a,'l'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_m
    ld      a,'m'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_o:
    ld      a,'o'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_p:
    ld      a,'p'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_r:
    ld      a,'r'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_s:
    ld      a,'s'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_t:
    ld      a,'t'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_u:
    ld      a,'u'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_n:
    ld      a,'n'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_i:
    ld      a,'i'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_g:
    ld      a,'g'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_y:
    ld      a,'y'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_bodka:
    ld      a,'.'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_dvojbodka:
    ld      a,':'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_minus:
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_space:
    ld      a,' '
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_zat1
    ld      a,'('
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
wm_zat2
    ld      a,')'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;Keyboard Test - Displaying pressed key
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_kbd_L1:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'1'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R1:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'1'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_L2:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'2'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R2:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'2'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_L3:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'3'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R3:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'3'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
w_kbd_LA:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'A'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_RA:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'A'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_kbd_L4:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'4'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R4:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'4'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_L5:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'5'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R5:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'5'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_L6:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'6'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R6:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'6'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
w_kbd_LB:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'B'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_RB:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'B'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_kbd_L7:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'7'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R7:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'7'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_L8:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'8'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R8:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'8'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_L9:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'9'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R9:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'9'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
w_kbd_LC:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'C'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_RC:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'C'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_kbd_Lstar:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'*'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_Rstar:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'*'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_L0:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'0'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_R0:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'0'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_Lmrizka:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'#'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_Rmrizka:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'#'
    out     (21h),a
    call    disp_del2
    ret
;-------------------------------------------------------
w_kbd_LD:
    ld      a,'L'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'D'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
w_kbd_RD:
    ld      a,'R'
    out     (21h),a
    call    disp_del2
    ld      a,'-'
    out     (21h),a
    call    disp_del2
    ld      a,'D'
    out     (21h),a
    call    disp_del2
    ret    
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------


;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_welcome:
    ld      a,10000000b
    out     (20h),a
    call    disp_del2
    
    ld      hl,txt_w1
    ld      b,20
w_welcome1:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_welcome1
;------------------------------
    ld      a,0C0h
    out     (20h),a
    call    disp_del2
    ld      hl,txt_w2
    ld      b,18
w_welcome2:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_welcome2
;------------------------------
    ld      a,94h
    out     (20h),a
    call    disp_del2

    ld      hl,txt_w3
    ld      b,17
w_welcome3:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_welcome3

;------------------------------
    ld      a,0D4h
    out     (20h),a
    call    disp_del2

    ld      hl,txt_w4
    ld      b,10
w_welcome4:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_welcome4

    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_ram_info
    ld      a,(v_ram)
    cp      01h
    jp      z,w_ram08
    
    cp      02h
    jp      z,w_ram16

    cp      03h
    jp      z,w_ram32

    cp      04h
    jp      z,w_ram64

    ret
;-------------------------------------------------------
;-------------------------------------------------------
w_ram08:
    call    wm_space
    call    wm_8
    call    wm_k
    call    wm_B
    ret
;-------------------------------------------------------
w_ram16:
    call    wm_1
    call    wm_6
    call    wm_k
    call    wm_B
    ret
;-------------------------------------------------------
w_ram32:
    call    wm_3
    call    wm_2
    call    wm_k
    call    wm_B
    ret
;-------------------------------------------------------
w_ram64:
    call    wm_6
    call    wm_4
    call    wm_k
    call    wm_B
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_main:
    ld      a,10010000b
    call    send_comm
    call    w_ram_info
    
    ld      a,10000000b
    out     (20h),a
    call    disp_del2
    
    ld      hl,txt_main1
    ld      b,10
w_main1:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_main1
;------------------------------
    ld      a,0C0h
    out     (20h),a
    call    disp_del2
    
    ld      hl,txt_main2
    ld      b,20
w_main2:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_main2
;------------------------------
    ld      a,094h
    out     (20h),a
    call    disp_del2
    
    ld      hl,txt_main3
    ld      b,20
w_main3:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_main3
;------------------------------
    ld      a,11010100b
    call    send_comm
    
    ld      hl,txt_main4
    ld      b,17
w_main4:
    ld      a,(hl)
    call    send_data
    inc     hl
    djnz    w_main4
;------------------------------
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
delay1s:
    push    de
    ld      e,00h
deli1s:
    dec     de
    ld      a,d
    or      e
    jp      nz,deli1s
    pop     de
    ret 
;-------------------------------------------------------
;-------------------------------------------------------
delay1:
    ld  bc,0005h
delo:
    ld  de,1000h
deli:
    dec de
    ld  a,d
    or  e
    jp  nz,deli
    
    dec bc
    ld  a,b
    or  c
    jp  nz,delo
    ret 
;-------------------------------------------------------
delay5:
    ld  bc,0010h
delo5:
    ld  de,1000h
deli5:
    dec de
    ld  a,d
    or  e
    jp  nz,deli5
    
    dec bc
    ld  a,b
    or  c
    jp  nz,delo5
    ret 
;-------------------------------------------------------
kbd_del3:
    ld  de,4000h
deli3:
    dec de
    ld  a,d
    or  e
    jp  nz,deli3
    ret 
;-------------------------------------------------------
;-------------------------------------------------------
kbd_del1:
    ld  de,0220h
deli1:
    dec de
    ld  a,d
    or  e
    jp  nz,deli1
    ret 
;-------------------------------------------------------
disp_del2:
    ld  de,0220h
deli2:
    dec de
    ld  a,d
    or  e
    jp  nz,deli2
    ret 
;-------------------------------------------------------
disp_del_data:
    ld  de,0010h
deli_data:
    dec de
    ld  a,d
    or  e
    jp  nz,deli_data
    ret 
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_bin8_a:
    ld      b,a
    
    bit     7,b
    call    z,wm_0
    call    nz,wm_1

    bit     6,b
    call    z,wm_0
    call    nz,wm_1
    
    bit     5,b
    call    z,wm_0
    call    nz,wm_1
    
    bit     4,b
    call    z,wm_0
    call    nz,wm_1
    
    bit     3,b
    call    z,wm_0
    call    nz,wm_1
    
    bit     2,b
    call    z,wm_0
    call    nz,wm_1
    
    bit     1,b
    call    z,wm_0
    call    nz,wm_1

    bit     0,b
    call    z,wm_0
    call    nz,wm_1
    
    ld      a,b
    ret
;-------------------------------------------------------
w_hex_a:
    push    af
    and     0f0h
    cp      000h
    call    z,wm_0
    cp      010h
    call    z,wm_1
    cp      020h
    call    z,wm_2
    cp      030h
    call    z,wm_3
    cp      040h
    call    z,wm_4
    cp      050h
    call    z,wm_5
    cp      060h
    call    z,wm_6
    cp      070h
    call    z,wm_7
    cp      080h
    call    z,wm_8
    cp      090h
    call    z,wm_9
    cp      0a0h
    call    z,wm_A
    cp      0b0h
    call    z,wm_B
    cp      0c0h
    call    z,wm_C
    cp      0d0h
    call    z,wm_D
    cp      0e0h
    call    z,wm_E
    cp      0f0h
    call    z,wm_F

    pop     af
    push    af
    and     0fh
    cp      00h
    call    z,wm_0
    cp      01h
    call    z,wm_1
    cp      02h
    call    z,wm_2
    cp      03h
    call    z,wm_3
    cp      04h
    call    z,wm_4
    cp      05h
    call    z,wm_5
    cp      06h
    call    z,wm_6
    cp      07h
    call    z,wm_7
    cp      08h
    call    z,wm_8
    cp      09h
    call    z,wm_9
    cp      0ah
    call    z,wm_A
    cp      0bh
    call    z,wm_B
    cp      0ch
    call    z,wm_C
    cp      0dh
    call    z,wm_D
    cp      0eh
    call    z,wm_E
    cp      0fh
    call    z,wm_F
    pop     af
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
w_key_code:
    ld      a,11010100b
    out     (20h),a
    call    disp_del2
    ld      a,'>'
    out     (21h),a
    call    disp_del2    
;----------------------------
    ld      hl,kbd_buffer
    ld      a,(hl)
    call    w_hex_a
    ret
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
demo2_data  .db 15h             ;delay to be used
            .db 06h             ;data length
            .db 10000001b       ;1
            .db 01000010b       ;2
            .db 00100100b       ;3
            .db 00011000b       ;4
            .db 00100100b       ;5
            .db 01000010b       ;6
;-------------------------------------------------------
;-------------------------------------------------------
demo3_data  .db 15h             ;delay to be used
            .db 10h             ;data length: 10h
            .db 10000000b       ;1
            .db 11000000b       ;2
            .db 11100000b       ;3
            .db 11110000b       ;4
            .db 11111000b       ;5
            .db 11111100b       ;6
            .db 11111110b       ;7
            .db 11111111b       ;8
            .db 11111110b       ;9
            .db 11111100b       ;10
            .db 11111000b       ;11
            .db 11110000b       ;12
            .db 11100000b       ;13
            .db 11000000b       ;14
            .db 10000000b       ;15
            .db 00000000b       ;16
;-------------------------------------------------------
;-------------------------------------------------------
demo4_data  .db 30h             ;delay to be used
            .db 011             ;data length
            .db 00000000b
            .db 00000001b
            .db 00000011b
            .db 00000111b
            .db 00001110b
            .db 00011100b
            .db 00111000b
            .db 01110000b
            .db 11100000b
            .db 11000000b
            .db 10000000b
;-------------------------------------------------------
;-------------------------------------------------------
demo5_data  .db 15h             ;delay to be used
            .db 018             ;data length
            .db 00000001b
            .db 00000011b
            .db 00000111b
            .db 00001110b
            .db 00011100b
            .db 00111000b
            .db 01110000b
            .db 11100000b
            .db 11000000b
            .db 10000000b
            .db 11000000b
            .db 11100000b
            .db 01110000b
            .db 00111000b
            .db 00011100b
            .db 00001110b
            .db 00000111b
            .db 00000011b
;-------------------------------------------------------
;-------------------------------------------------------
rtc_buffer  .db 00h
rtc_sec     .db 00h
rtc_min     .db 00h
rtc_hrs     .db 00h
rtc_wday    .db 00h
rtc_day     .db 00h
rtc_mnt     .db 00h
rtc_year    .db 00h
;-------------------------------------------------------
;-------------------------------------------------------
;-------------------------------------------------------
txt_w1:     .db "EC-2022             "
txt_w2:     .db "Based on PMI-80   "
txt_w3:     .db "Firmware v1.30.01"
txt_w4:     .db "17.01.2022"
;-------------------------------------------------------
txt_main1   .db "(0) Demos "
txt_main2   .db "(A) Memory / (9) RTC"
txt_main3   .db "(B) Exec   / (8) I2C"
txt_main4   .db "(C) Register Dump"
;-------------------------------------------------------
kbd_buffer  .db 0FFh
;-------------------------------------------------------
edit_hex_dp   .db 086h
edit_hex_byte .db 00h
;-------------------------------------------------------
v_counter     .db 00h
;-------------------------------------------------------
;-------------------------------------------------------
v_ram        .db 00h
;-------------------------------------------------------
i2c_buffer   .db 00h
;-------------------------------------------------------